//+------------------------------------------------------------------+
//|                                                        Pivot.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window

extern bool ManualCalculation = false;
extern double LastWeek_high = 0;
extern double LastWeek_low  = 0;
extern double LastWeek_close = 0;

double P=0;
double Q=0;
double H4,H3,H2,H1,L0,L1,L2,L3,L4;
double nQ=0;
double nD=0;
double D=0;
double rates_d1[2][6];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
 H4=0; H3=0; H2=0; H1=0; L0=0; L1=0; L2=0; L3=0; L4=0;

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here

ObjectDelete("WP Label");
ObjectDelete("WP Line");

ObjectDelete("WH4 Label");
ObjectDelete("WH4 Line");
ObjectDelete("WH3 Label");
ObjectDelete("WH3 Line");
ObjectDelete("WH2 Label");
ObjectDelete("WH2 Line");
ObjectDelete("WH1 Label");
ObjectDelete("WH1 Line");
ObjectDelete("WL0 Label");
ObjectDelete("WL0 Line");
ObjectDelete("WL1 Label");
ObjectDelete("WL1 Line");
ObjectDelete("WL2 Label");
ObjectDelete("WL2 Line");
ObjectDelete("WL3 Label");
ObjectDelete("WL3 Line");
ObjectDelete("WL4 Label");
ObjectDelete("WL4 Line");

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

//---- TODO: add your code here

//---- exit if period is greater than daily charts
if(Period() > 1440)
{
Print("Error - Chart period is greater than 1 day.");
return(-1); // then exit
}

//---- Get new daily prices

ArrayCopyRates(rates_d1, Symbol(), PERIOD_W1);
if ( ManualCalculation == false)
{
LastWeek_close = rates_d1[1][4];
LastWeek_high = rates_d1[1][3];
LastWeek_low = rates_d1[1][2];
}



//---- Calculate Pivots

Q = (LastWeek_high - LastWeek_low);
P = (LastWeek_high + LastWeek_low + LastWeek_close) / 3;


	H4 = (Q*1.09)+LastWeek_close;
	H3 = (Q*0.82)+LastWeek_close;
	H2 = (Q*0.55)+LastWeek_close;
   H1 = (Q*0.27)+LastWeek_close;
   L0 = LastWeek_close;
	L1 = LastWeek_close-(Q*0.27);
	L2 = LastWeek_close-(Q*0.55);
	L3 = LastWeek_close-(Q*0.82);	
	L4 = LastWeek_close-(Q*1.09);
	

if (Q > 5) 
{
	nQ = Q;
}
else
{
	nQ = Q*10000;
}

if (D > 5)
{
	nD = D;
}
else
{
	nD = D*10000;
}


Comment("High= ",LastWeek_high,"    Previous Days Range= ",nQ,"\nLow= ",LastWeek_low,"    Current Days Range= ",nD,"\nClose= ",LastWeek_close);

//---- Set line labels on chart window

//---- Pivot Lines


      if(ObjectFind("WP label") != 0)
      {
      ObjectCreate("WP label", OBJ_TEXT, 0, Time[0], P);
      ObjectSetText("WP label", "Weekly Pivot", 9, "Arial", Yellow);
      }
      else
      {
      ObjectMove("WP label", 0, Time[0], P);
      }


//---  Draw  Pivot lines on chart


      if(ObjectFind("WP line") != 0)
      {
      ObjectCreate("WP line", OBJ_HLINE, 0, Time[40], P);
      ObjectSet("WP line", OBJPROP_STYLE, STYLE_DASH);
      ObjectSet("WP line", OBJPROP_WIDTH, 0);
      ObjectSet("WP line", OBJPROP_COLOR, Yellow);
      }
      else
      {
      ObjectMove("WP line", 0, Time[40], P);
      }





      if(ObjectFind("WH4 label") != 0)
      {
      ObjectCreate("WH4 label", OBJ_TEXT, 0, Time[10], H4);
      ObjectSetText("WH4 label", "Weekly H6", 9, "Arial", Lime);
      }
      else
      {
      ObjectMove("WH4 label", 0, Time[10], H4);
      }

      if(ObjectFind("WH3 label") != 0)
      {
      ObjectCreate("WH3 label", OBJ_TEXT, 0, Time[10], H3);
      ObjectSetText("WH3 label", "Weekly H5", 9, "Arial", Lime);
      }
      else
      {
      ObjectMove("WH3 label", 0, Time[10], H3);
      }


      if(ObjectFind("WH2 label") != 0)
      {
      ObjectCreate("WH2 label", OBJ_TEXT, 0, Time[10], H2);
      ObjectSetText("WH2 label", "Weekly H4", 9, "Arial", Lime);
      }
      else
      {
      ObjectMove("WH2 label", 0, Time[10], H2);
      }


      if(ObjectFind("WH1 label") != 0)
      {
      ObjectCreate("WH1 label", OBJ_TEXT, 0, Time[10], H1);
      ObjectSetText("WH1 label", "Weekly H3", 9, "Arial", Magenta);
      }
      else
      {
      ObjectMove("WH1 label", 0, Time[10], H1);
      }



      if(ObjectFind("WL0 label") != 0)
      {
      ObjectCreate("WL0 label", OBJ_TEXT, 0, Time[10], L0);
      ObjectSetText("WL0 label", "Weekly Open", 9, "Arial", Aqua);
      }
      else
      {
      ObjectMove("WL0 label", 0, Time[10], L0);
      }
      
      
      
      if(ObjectFind("WL1 label") != 0)
      {
      ObjectCreate("WL1 label", OBJ_TEXT, 0, Time[10], L1);
      ObjectSetText("WL1 label", "Weekly L3", 9, "Arial", Magenta);
      }
      else
      {
      ObjectMove("WL1 label", 0, Time[10], L1);
      }



      if(ObjectFind("WL2 label") != 0)
      {
      ObjectCreate("WL2 label", OBJ_TEXT, 0, Time[10], L2);
      ObjectSetText("WL2 label", "Weekly L4", 9, "Arial", Red);
      }
      else
      {
      ObjectMove("WL2 label", 0, Time[10], L2);
      }

      if(ObjectFind("WL3 label") != 0)
      {
      ObjectCreate("WL3 label", OBJ_TEXT, 0, Time[10], L3);
      ObjectSetText("WL3 label", "Weekly L5", 9, "Arial", Red);
      }
      else
      {
      ObjectMove("WL3 label", 0, Time[10], L3);
      }

      if(ObjectFind("WL4 label") != 0)
      {
      ObjectCreate("WL4 label", OBJ_TEXT, 0, Time[10], L4);
      ObjectSetText("WL4 label", "Weekly L6", 9, "Arial", Red);
      }
      else
      {
      ObjectMove("WL4 label", 0, Time[10], L4);
      }

//---- Draw Camarilla lines on Chart
      if(ObjectFind("WH4 line") != 0)
      {
      ObjectCreate("WH4 line", OBJ_HLINE, 0, Time[40], H4);
      ObjectSet("WH4 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("WH4 line", OBJPROP_WIDTH, 2);
      ObjectSet("WH4 line", OBJPROP_COLOR, Lime);
      }
      else
      {
      ObjectMove("WH4 line", 0, Time[40], H4);
      }

      if(ObjectFind("WH3 line") != 0)
      {
      ObjectCreate("WH3 line", OBJ_HLINE, 0, Time[40], H3);
      ObjectSet("WH3 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("WH3 line", OBJPROP_WIDTH, 2);
      ObjectSet("WH3 line", OBJPROP_COLOR, Lime);
      }
      else
      {
      ObjectMove("WH3 line", 0, Time[40], H3);
      }
      
      
      
            if(ObjectFind("WH2 line") != 0)
      {
      ObjectCreate("WH2 line", OBJ_HLINE, 0, Time[40], H2);
      ObjectSet("WH2 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("WH2 line", OBJPROP_WIDTH, 2);
      ObjectSet("WH2 line", OBJPROP_COLOR, Lime);
      }
      else
      {
      ObjectMove("WH2 line", 0, Time[40], H2);
      }


      if(ObjectFind("WH1 line") != 0)
      {
      ObjectCreate("WH1 line", OBJ_HLINE, 0, Time[40], H1);
      ObjectSet("WH1 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("WH1 line", OBJPROP_WIDTH, 2);
      ObjectSet("WH1 line", OBJPROP_COLOR, Magenta);
      }
      else
      {
      ObjectMove("WH1 line", 0, Time[40], H1);
      }


      if(ObjectFind("WL0 line") != 0)
      {
      ObjectCreate("WL0 line", OBJ_HLINE, 0, Time[40], L0);
      ObjectSet("WL0 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("WL0 line", OBJPROP_WIDTH, 2);
      ObjectSet("WL0 line", OBJPROP_COLOR, Aqua);
      }
      else
      {
      ObjectMove("WL0 line", 0, Time[40], L0);
      }
      
      
      
      if(ObjectFind("WL1 line") != 0)
      {
      ObjectCreate("WL1 line", OBJ_HLINE, 0, Time[40], L1);
      ObjectSet("WL1 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("WL1 line", OBJPROP_WIDTH, 2);
      ObjectSet("WL1 line", OBJPROP_COLOR, Magenta);
      }
      else
      {
      ObjectMove("WL1 line", 0, Time[40], L1);
      }


      if(ObjectFind("WL2 line") != 0)
      {
      ObjectCreate("WL2 line", OBJ_HLINE, 0, Time[40], L2);
      ObjectSet("WL2 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("WL2 line", OBJPROP_WIDTH, 2);
      ObjectSet("WL2 line", OBJPROP_COLOR, Red);
      }
      else
      {
      ObjectMove("WL2 line", 0, Time[40], L2);
      }

      if(ObjectFind("WL3 line") != 0)
      {
      ObjectCreate("WL3 line", OBJ_HLINE, 0, Time[40], L3);
      ObjectSet("WL3 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("WL3 line", OBJPROP_WIDTH, 2);
      ObjectSet("WL3 line", OBJPROP_COLOR, Red);
      
      }
      else
      {
      ObjectMove("WL3 line", 0, Time[40], L3);
      }

      if(ObjectFind("WL4 line") != 0)
      {
      ObjectCreate("WL4 line", OBJ_HLINE, 0, Time[40], L4);
      ObjectSet("WL4 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("WL4 line", OBJPROP_WIDTH, 2);
      ObjectSet("WL4 line", OBJPROP_COLOR, Red);
      }
      else
      {
      ObjectMove("WL4 line", 0, Time[40], L4);
      }


 
//---- End Of Program
   return(0);
  }
//+------------------------------------------------------------------+