//+------------------------------------------------------------------+
//|                                                        Pivot.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window

extern bool camarilla = true;

double day_high=0;
double day_low=0;
double yesterday_high=0;
double yesterday_open=0;
double yesterday_low=0;
double yesterday_close=0;
double today_open=0;
double today_high=0;
double today_low=0;
double LastWeek_high=0;
double LastWeek_open=0;
double LastWeek_low=0;
double LastWeek_close=0;
double LastMonth_high=0;
double LastMonth_open=0;
double LastMonth_low=0;
double LastMonth_close=0;
double P=0,WP=0,MP=0;
double Q=0;
double H4,H3,H2,H1,L0,L1,L2,L3,L4;
double nQ=0;
double nD=0;
double D=0;
double rates_d1[2][6];
double rates_w1[2][6];
double rates_m1[2][6];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
 
 H4=0; H3=0; H2=0; H1=0; L0=0; L1=0; L2=0; L3=0; L4=0;

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
ObjectDelete("P Label");
ObjectDelete("P Line");
ObjectDelete("H4 Label");
ObjectDelete("H4 Line");
ObjectDelete("H3 Label");
ObjectDelete("H3 Line");
ObjectDelete("H2 Label");
ObjectDelete("H2 Line");
ObjectDelete("H1 Label");
ObjectDelete("H1 Line");
ObjectDelete("L0 Label");
ObjectDelete("L0 Line");
ObjectDelete("L1 Label");
ObjectDelete("L1 Line");
ObjectDelete("L2 Label");
ObjectDelete("L2 Line");
ObjectDelete("L3 Label");
ObjectDelete("L3 Line");
ObjectDelete("L4 Label");
ObjectDelete("L4 Line");

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

//---- TODO: add your code here

//---- exit if period is greater than daily charts
if(Period() > 1440)
{
Print("Error - Chart period is greater than 1 day.");
return(-1); // then exit
}

//---- Get new daily prices

ArrayCopyRates(rates_d1, Symbol(), PERIOD_D1);

yesterday_close = rates_d1[1][4];
yesterday_open = rates_d1[1][1];
today_open = rates_d1[0][1];
yesterday_high = rates_d1[1][3];
yesterday_low = rates_d1[1][2];
day_high = rates_d1[0][3];
day_low = rates_d1[0][2];


//---- Calculate Pivots

D = (day_high - day_low);
Q = (yesterday_high - yesterday_low);
P = (yesterday_high + yesterday_low + yesterday_close) / 3;


	H4 = (Q*1.09)+yesterday_close;
	H3 = (Q*0.82)+yesterday_close;
	H2 = (Q*0.55)+yesterday_close;
   H1 = (Q*0.27)+yesterday_close;
	L0 = yesterday_close;
	L1 = yesterday_close-(Q*0.27);
	L2 = yesterday_close-(Q*0.55);
	L3 = yesterday_close-(Q*0.82);	
	L4 = yesterday_close-(Q*1.09);
	
	
if (Q > 5) 
{
	nQ = Q;
}
else
{
	nQ = Q*10000;
}

if (D > 5)
{
	nD = D;
}
else
{
	nD = D*10000;
}


Comment("High= ",yesterday_high,"    Previous Days Range= ",nQ,"\nLow= ",yesterday_low,"    Current Days Range= ",nD,"\nClose= ",yesterday_close);

//---- Set line labels on chart window



      if(ObjectFind("P label") != 0)
      {
      ObjectCreate("P label", OBJ_TEXT, 0, Time[0], P);
      ObjectSetText("P label", "Daily Pivot", 10, "Arial", Yellow);
      }
      else
      {
      ObjectMove("P label", 0, Time[0], P);
      }

      

      if(ObjectFind("P line") != 0)
      {
      ObjectCreate("P line", OBJ_HLINE, 0, Time[40], P);
      ObjectSet("P line", OBJPROP_STYLE, STYLE_DASH);
      ObjectSet("P line", OBJPROP_COLOR, Yellow);
      }
      else
      {
      ObjectMove("P line", 0, Time[40], P);
      }

      

//----- Camarilla Lines

   if (camarilla==true)
   {
      if(ObjectFind("H4 label") != 0)
      {
      ObjectCreate("H4 label", OBJ_TEXT, 0, Time[10], H4);
      ObjectSetText("H4 label", "H 6", 10, "Arial", Lime);
      }
      else
      {
      ObjectMove("H4 label", 0, Time[10], H4);
      }

      if(ObjectFind("H3 label") != 0)
      {
      ObjectCreate("H3 label", OBJ_TEXT, 0, Time[10], H3);
      ObjectSetText("H3 label", "H 5", 10, "Arial", Lime);
      }
      else
      {
      ObjectMove("H3 label", 0, Time[10], H3);
      }


      if(ObjectFind("H2 label") != 0)
      {
      ObjectCreate("H2 label", OBJ_TEXT, 0, Time[10], H2);
      ObjectSetText("H2 label", "H 4", 10, "Arial", Lime);
      }
      else
      {
      ObjectMove("H2 label", 0, Time[10], H2);
      }


      if(ObjectFind("H1 label") != 0)
      {
      ObjectCreate("H1 label", OBJ_TEXT, 0, Time[10], H1);
      ObjectSetText("H1 label", "H 3", 10, "Arial", Magenta);
      }
      else
      {
      ObjectMove("H1 label", 0, Time[10], H1);
      }



      if(ObjectFind("L0 label") != 0)
      {
      ObjectCreate("L0 label", OBJ_TEXT, 0, Time[10], L1);
      ObjectSetText("L0 label", "Open", 10, "Arial", Aqua);
      }
      else
      {
      ObjectMove("L0 label", 0, Time[10], L0);
      }
      
      
      
      if(ObjectFind("L1 label") != 0)
      {
      ObjectCreate("L1 label", OBJ_TEXT, 0, Time[10], L1);
      ObjectSetText("L1 label", "L 3", 10, "Arial", Magenta);
      }
      else
      {
      ObjectMove("L1 label", 0, Time[10], L1);
      }



      if(ObjectFind("L2 label") != 0)
      {
      ObjectCreate("L2 label", OBJ_TEXT, 0, Time[10], L2);
      ObjectSetText("L2 label", "L 4", 10, "Arial", Red);
      }
      else
      {
      ObjectMove("L2 label", 0, Time[10], L2);
      }

      if(ObjectFind("L3 label") != 0)
      {
      ObjectCreate("L3 label", OBJ_TEXT, 0, Time[10], L3);
      ObjectSetText("L3 label", "L 5", 10, "Arial", Red);
      }
      else
      {
      ObjectMove("L3 label", 0, Time[10], L3);
      }

      if(ObjectFind("L4 label") != 0)
      {
      ObjectCreate("L4 label", OBJ_TEXT, 0, Time[10], L4);
      ObjectSetText("L4 label", "L 6", 10, "Arial", Red);
      }
      else
      {
      ObjectMove("L4 label", 0, Time[10], L4);
      }

//---- Draw Camarilla lines on Chart
      if(ObjectFind("H4 line") != 0)
      {
      ObjectCreate("H4 line", OBJ_HLINE, 0, Time[40], H4);
      ObjectSet("H4 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("H4 line", OBJPROP_WIDTH, 1);
      ObjectSet("H4 line", OBJPROP_COLOR, Lime);
      }
      else
      {
      ObjectMove("H4 line", 0, Time[40], H4);
      }

      if(ObjectFind("H3 line") != 0)
      {
      ObjectCreate("H3 line", OBJ_HLINE, 0, Time[40], H3);
      ObjectSet("H3 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("H3 line", OBJPROP_WIDTH, 1);
      ObjectSet("H3 line", OBJPROP_COLOR, Lime);
      }
      else
      {
      ObjectMove("H3 line", 0, Time[40], H3);
      }
      
      
      
            if(ObjectFind("H2 line") != 0)
      {
      ObjectCreate("H2 line", OBJ_HLINE, 0, Time[40], H2);
      ObjectSet("H2 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("H2 line", OBJPROP_COLOR, Lime);
      }
      else
      {
      ObjectMove("H2 line", 0, Time[40], H2);
      }


      if(ObjectFind("H1 line") != 0)
      {
      ObjectCreate("H1 line", OBJ_HLINE, 0, Time[40], H1);
      ObjectSet("H1 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("H1 line", OBJPROP_WIDTH, 3);
      ObjectSet("H1 line", OBJPROP_COLOR, Magenta);
      }
      else
      {
      ObjectMove("H1 line", 0, Time[40], H1);
      }


      if(ObjectFind("L0 line") != 0)
      {
      ObjectCreate("L0 line", OBJ_HLINE, 0, Time[40], L0);
      ObjectSet("L0 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("L0 line", OBJPROP_WIDTH, 2);
      ObjectSet("L0 line", OBJPROP_COLOR, Aqua);
      }
      else
      {
      ObjectMove("L0 line", 0, Time[40], L0);
      }
      
      
      if(ObjectFind("L1 line") != 0)
      {
      ObjectCreate("L1 line", OBJ_HLINE, 0, Time[40], L1);
      ObjectSet("L1 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("L1 line", OBJPROP_WIDTH, 3);
      ObjectSet("L1 line", OBJPROP_COLOR, Magenta);
      }
      else
      {
      ObjectMove("L1 line", 0, Time[40], L1);
      }


      if(ObjectFind("L2 line") != 0)
      {
      ObjectCreate("L2 line", OBJ_HLINE, 0, Time[40], L2);
      ObjectSet("L2 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("L2 line", OBJPROP_WIDTH, 1);
      ObjectSet("L2 line", OBJPROP_COLOR, Red);
      }
      else
      {
      ObjectMove("L2 line", 0, Time[40], L2);
      }

      if(ObjectFind("L3 line") != 0)
      {
      ObjectCreate("L3 line", OBJ_HLINE, 0, Time[40], L3);
      ObjectSet("L3 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("L3 line", OBJPROP_WIDTH, 1);
      ObjectSet("L3 line", OBJPROP_COLOR, Red);
      
      }
      else
      {
      ObjectMove("L3 line", 0, Time[40], L3);
      }

      if(ObjectFind("L4 line") != 0)
      {
      ObjectCreate("L4 line", OBJ_HLINE, 0, Time[40], L4);
      ObjectSet("L4 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("L4 line", OBJPROP_WIDTH, 1);
      ObjectSet("L4 line", OBJPROP_COLOR, Red);
      }
      else
      {
      ObjectMove("L4 line", 0, Time[40], L4);
      }
   }
//-------End of Draw Camarilla Lines


 
//---- End Of Program
   return(0);
  }
//+------------------------------------------------------------------+